TimeZoneNameProvider (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.spi, class: TimeZoneNameProvider
Keywords: java.util.spi.TimeZoneNameProvider class

# Class TimeZoneNameProvider

java.lang.Object
java.util.spi.LocaleServiceProvider
java.util.spi.TimeZoneNameProvider

public abstract class TimeZoneNameProvider extends LocaleServiceProvider
An abstract class for service providers that provide localized time zone names for the `TimeZone` class. The localized time zone names available from the implementations of this class are also the source for the `DateFormatSymbols.getZoneStrings()` method.

Since:
  1.6

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TimeZoneNameProvider()`
  Sole constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract String`
  `getDisplayName(String ID, boolean daylight, int style, Locale locale)`
  Returns a name for the given time zone ID that's suitable for presentation to the user in the specified locale.
  `String`
  `getGenericDisplayName(String ID, int style, Locale locale)`
  Returns a generic name for the given time zone `ID` that's suitable for presentation to the user in the specified `locale`.

  ### Methods declared in class LocaleServiceProvider

  `getAvailableLocales, isSupportedLocale`
  Modifier and Type
  Method
  Description
  `abstract Locale[]`
  `getAvailableLocales()`
  Returns an array of all locales for which this locale service provider can provide localized objects or names.
  `boolean`
  `isSupportedLocale(Locale locale)`
  Returns `true` if the given `locale` is supported by this locale service provider.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### TimeZoneNameProvider

    protected TimeZoneNameProvider()
    Sole constructor. (For invocation by subclass constructors, typically implicit.)

- ## Method Details

  - ### getDisplayName

    public abstract String getDisplayName(String ID, boolean daylight, int style, Locale locale)
    Returns a name for the given time zone ID that's suitable for presentation to the user in the specified locale. The given time zone ID is "GMT" or one of the names defined using "Zone" entries in the "tz database", a public domain time zone database at https://www.iana.org/time-zones. The data of this database is contained in a file whose name starts with "tzdata", and the specification of the data format is part of the zic.8 man page, which is contained in a file whose name starts with "tzcode".

    If `daylight` is true, the method should return a name appropriate for daylight saving time even if the specified time zone has not observed daylight saving time in the past.

    Parameters:
      `ID` - a time zone ID string
      `daylight` - if true, return the daylight saving name.
      `style` - either `TimeZone.LONG` or `TimeZone.SHORT`
      `locale` - the desired locale
    Returns:
      the human-readable name of the given time zone in the given locale, or null if it's not available.
    Throws:
      `IllegalArgumentException` - if `style` is invalid, or `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `ID` or `locale` is null
    External Specifications
      - Time Zone Database
    See Also:
      - `TimeZone.getDisplayName(boolean, int, java.util.Locale)`

  - ### getGenericDisplayName

    public String getGenericDisplayName(String ID, int style, Locale locale)
    Returns a generic name for the given time zone `ID` that's suitable for presentation to the user in the specified `locale`. Generic time zone names are neutral from standard time and daylight saving time. For example, "PT" is the short generic name of time zone ID `America/Los_Angeles`, while its short standard time and daylight saving time names are "PST" and "PDT", respectively. Refer to `getDisplayName` for valid time zone IDs.

    The default implementation of this method returns `null`.

    Parameters:
      `ID` - a time zone ID string
      `style` - either `TimeZone.LONG` or `TimeZone.SHORT`
      `locale` - the desired locale
    Returns:
      the human-readable generic name of the given time zone in the given locale, or `null` if it's not available.
    Throws:
      `IllegalArgumentException` - if `style` is invalid, or `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `ID` or `locale` is `null`
    Since:
      1.8